// *****************************************************************
// *                                                               *
// *       Copyright (c) Fast Corporation, 2005                    *
// *                                                               *
// *   All Rights Reserved.  Unpublished rights  reserved  under   *
// *   the copyright laws of the Japan.                            *
// *                                                               *
// *   The software contained on this media  is  proprietary  to   *
// *   and  embodies  the  confidential  technology  of  Fast      *
// *   Corporation.  Possession, use,  duplication  or             *
// *   dissemination of the software and media is authorized only  *
// *   pursuant to a valid written license from Fast Corporation.  *
// *                                                               *
// *****************************************************************

// -------------------------------------------------------------------
// FVX Sample Program
// 
//
// 쐬 : K.Yakushinji
//    : 2005/08/08 
//
//-------------------------------------------------------------------

// BlobDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "Blob.h"
#include "BlobDlg.h"
#include "LicenceDlg.h"
#include "ConfFileDlg.h"
#include "BlobResultDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// AvP[Ṽo[WŎgĂ CAboutDlg _CAO

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// _CAO f[^
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard ͉z֐̃I[o[Ch𐶐܂
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV ̃T|[g
	//}}AFX_VIRTUAL

// Cve[V
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// bZ[W nh܂B
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBlobDlg _CAO

CBlobDlg::CBlobDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CBlobDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CBlobDlg)
	m_color = 0;
	m_binlevel = 128;
	m_exetime = _T("");
	m_minsize = 5;
	m_maxsize = 245760;
	m_angle = 0.0;
	m_arrange = -1;
	m_wndtouch = FALSE;
	//}}AFX_DATA_INIT
	// : LoadIcon  Win32  DestroyIcon ̃TuV[PXv܂B
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_blnVideoOpened = false;
}

void CBlobDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBlobDlg)
	DDX_CBIndex(pDX, IDC_COLOR, m_color);
	DDX_Text(pDX, IDC_BINLEVEL, m_binlevel);
	DDV_MinMaxInt(pDX, m_binlevel, 0, 255);
	DDX_Text(pDX, IDC_EXETIME, m_exetime);
	DDX_Text(pDX, IDC_MINSIZE, m_minsize);
	DDX_Text(pDX, IDC_MAXSIZE, m_maxsize);
	DDX_Text(pDX, IDC_ANGLE, m_angle);
	DDX_Radio(pDX, IDC_ARRANGE0, m_arrange);
	DDX_Check(pDX, IDC_WNDTOUCH, m_wndtouch);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CBlobDlg, CDialog)
	//{{AFX_MSG_MAP(CBlobDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_SIZE()
	ON_BN_CLICKED(IDC_GRAB, OnGrab)
	ON_BN_CLICKED(IDC_EXEREGION, OnExeregion)
	ON_EN_CHANGE(IDC_BINLEVEL, OnChangeBinlevel)
	ON_BN_CLICKED(IDC_CLEAR, OnClear)
	ON_BN_CLICKED(IDC_LOADIMAGE, OnLoadimage)
	ON_BN_CLICKED(IDC_SAVEIMAGE, OnSaveimage)
	ON_BN_CLICKED(IDC_EXECUTE, OnExecute)
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBlobDlg bZ[W nh

BOOL CBlobDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// "o[W..." j[ڂVXe j[֒ǉ܂B

	// IDM_ABOUTBOX ̓R}h j[͈̔͂łȂ΂Ȃ܂B
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// ̃_CAOp̃ACRݒ肵܂Bt[[N̓AvP[ṼC
	// EBhE_CAOłȂ͎Iɐݒ肵܂B
	SetIcon(m_hIcon, TRUE);			// 傫ACRݒ
	SetIcon(m_hIcon, FALSE);		// ACRݒ
	
	// TODO: ʂȏs͂̏ꏊɒǉĂB
	/* -------------------------------------------------------------------------------- */
	// FvxSample 
	CLicenceDlg dlg;
	CConfFileDlg fdlg;

	// CZXʂ̕\
	if (dlg.DoModal() == IDOK){

		//Ӂ
		// ߂COM̏sƂYȂłB
		CoInitialize( NULL );
		CWnd *pwnd ;
		IUnknown *p_unknown;
		long err_no = 0 ;

		// _CAOɓ\tĂFvxDisplayEx̃CX^X擾AX}[g|C^Ɋt܂B
		pwnd = GetDlgItem( IDC_FVXDISPLAYEX1 );		// FvxDisplayEx̃nh擾
		p_unknown = pwnd->GetControlUnknown();		// Rg[̎IUnknownC^[tFCX擾
		p_unknown->QueryInterface( __uuidof(IFvxDisplayEx2Ptr) , (void**)&m_FvxDisplayEx );

		// eFvxRg[̃CX^X𐶐܂B
		// w肷NXԈႦȂ悤ӂĂB
		m_FvxChangeImage.CreateInstance( __uuidof( FvxChangeImage ) ); 
		m_FvxFileAccess.CreateInstance( __uuidof( FvxFileAccess ) ); 
		m_FvxImageGray.CreateInstance( __uuidof( FvxImage ) ); 
		m_FvxImageBin.CreateInstance( __uuidof( FvxImage ) ); 
		m_FvxImageTemp.CreateInstance( __uuidof( FvxImage ) ); 
		m_FvxVideo.CreateInstance( __uuidof( FvxVideo ) ); 
		m_FvxROI.CreateInstance( __uuidof( FvxROI ) ); 
		m_FvxPerformanceCounter.CreateInstance( __uuidof( FvxPerformanceCounter ) ); 
		m_FvxBlob.CreateInstance( __uuidof( FvxBlob ) ); 
		m_ExeRegion.CreateInstance( __uuidof( FvRectangle ) ); 

		// fBXvC̏
		m_FvxDisplayEx->CreateDisplay( 1 , 0 );

		// Ql\
		m_FvxChangeImage->FixedLevel( m_FvxImageGray, m_FvxImageBin, 128 );
		m_FvxDisplayEx->DrawImage( m_FvxImageBin );

		// ͈͂̏lݒi摜̑Oʂɐݒj
		m_ExeRegion->Putxs( -1 );
		m_ExeRegion->Putxe( -1 );
		m_ExeRegion->Putys( -1 );
		m_ExeRegion->Putye( -1 );

		m_FvxDisplayEx->PutPenColor( 0xFF0000 );
		m_FvxDisplayEx->DrawData( 0, m_ExeRegion );

		// Rg[ނ̏
		CComboBox*    pcmb;
		pcmb = ( CComboBox* )GetDlgItem( IDC_COLOR );
		pcmb->AddString( "BLACK" );
		pcmb->AddString( "WHITE" );
		m_color = 0;
		m_arrange = 0 ;
		UpdateData(FALSE); 

		// rfIݒt@C̑I
		fdlg.DoModal();

		if ( fdlg.m_check == FALSE ) {
			
		    // rfIݒt@CR|[lgɐݒ
 			m_FvxVideo->PutVideoConfFile( _bstr_t( fdlg.m_conffile ));

			// rfIfoCXI[v
			try {

				m_FvxVideo->OpenDevice();

			} catch( _com_error ) {
			
				m_FvxVideo->GetErrReport( &err_no );
				MessageBox("rfIfoCX̃I[vɎs܂\r\n摜t@Ĉ݂̗pɂȂ܂B" , "G[" , MB_ICONWARNING | MB_OK );
				return TRUE;  // TRUE ԂƃRg[ɐݒ肵tH[JX͎܂B
			}

			// VideoConfFile̕ύXAOpenDevicesƁAgK[[h̕ύX܂
			// ̂߁AЃLv`{[hFVC02ł350ms̃ZbgAbv^CKvɂȂ܂
			// {vOł͊ȗ̂߂ɁAꗥ350ms̃ZbgAbv^CmۂĂ܂A
			// g̃Lv`{[hɍ킹ĕύXĂB
			::Sleep( 350 );

			// GrabSync/GrabASync\bhłImageTCY̕ύXs܂̂ŁA
            // 炩ChangeImageSize\bhɂImagẽTCYύXĂ
            //i荞݃TCYImagẽTCYႤꍇG[ɂȂ܂j
			m_FvxVideo->ChangeImageSize( m_FvxImageGray );

			try	{

				// 捞
				m_FvxVideo->GrabSync( m_FvxImageGray );

			} catch(_com_error ) {
			
				m_FvxVideo->GetErrReport( &err_no );
				MessageBox("rfI̎捞Ɏs܂\r\n摜t@Ĉ݂̗pɂȂ܂B" , "G[" , MB_ICONWARNING | MB_OK );
				return TRUE;  // TRUE ԂƃRg[ɐݒ肵tH[JX͎܂B

			}

			// J荞ݗL
			GetDlgItem( IDC_GRAB )->EnableWindow( TRUE );
			// rfIfoCX̏ԂL
			m_blnVideoOpened = true;

		}

		// 摜̕\
		m_FvxDisplayEx->DrawImage( m_FvxImageGray );
		// Ql\
		m_FvxChangeImage->FixedLevel( m_FvxImageGray, m_FvxImageBin, 128 );
		m_FvxDisplayEx->DrawImage( m_FvxImageBin );

	}else{

		// ӂĂ炦Ȃ瑦I
		EndDialog( IDCANCEL );
	}
	
	UpdateData(FALSE); 
	return TRUE;  // TRUE ԂƃRg[ɐݒ肵tH[JX͎܂B
}

void CBlobDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// _CAO{bNXɍŏ{^ǉȂ΁AACR`悷
// R[hȉɋLqKv܂BMFC AvP[V document/view
// fgĂ̂ŁȀ̓t[[Nɂ莩Iɏ܂B

void CBlobDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `p̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// NCAg̋`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR`悵܂B
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// VXéA[U[ŏEBhEhbOĂԁA
// J[\\邽߂ɂĂяo܂B
HCURSOR CBlobDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

BOOL CBlobDlg::PreTranslateMessage(MSG* pMsg) 
{
	// TODO: ̈ʒuɌŗL̏ǉ邩A܂͊{NXĂяoĂ
	if(pMsg->message == WM_KEYDOWN)
	{
		switch( pMsg->wParam )
		{
			case VK_RETURN:
			case VK_ESCAPE:
				return false;
		}
	}
	
	return CDialog::PreTranslateMessage(pMsg);
}

void CBlobDlg::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);
	
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ
	if (IsIconic() == 0 ) {

		if ( m_FvxDisplayEx != NULL ){

			CWnd *pwnd;
			CRect rect;

			pwnd = GetDlgItem( IDC_FVXDISPLAYEX1 );
			pwnd->GetWindowRect( rect );

			// XN[WNCAgWɕϊ
			ScreenToClient( rect );

			// FvxDisplayEx̃TCYύX
			pwnd->MoveWindow( rect.left , rect.top, cx - (rect.left + 20) , cy - (rect.top + 20) , TRUE );

		}
	}
	
}

void CBlobDlg::OnGrab() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	UpdateData( TRUE );

	long BinLevel = 0;

	BinLevel = m_binlevel;
    
    if ( BinLevel < 0 ) BinLevel = 0 ;
    if ( BinLevel > 255 ) BinLevel = 255 ;
    
    m_FvxVideo->GrabSync( m_FvxImageGray );     // 捞
    m_FvxChangeImage->FixedLevel( m_FvxImageGray, m_FvxImageBin, BinLevel );
    m_FvxDisplayEx->DrawImage( m_FvxImageBin );

}

void CBlobDlg::OnExeregion() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	long lngOK = 0;
	double dblTemp = 0;
	
	UpdateData(TRUE);

    m_FvxROI->SetRectangle( m_ExeRegion );

    // FvxROIgď͈͑I_CAOo܂
    m_FvxROI->PutUsePoint( false );
	m_FvxROI->MakeROIDialog( m_FvxImageBin, &lngOK);

    if ((lngOK == 1) && (m_FvxROI->GetCheckRectangle() == 1)) {
        m_FvxROI->GetRectangle( m_ExeRegion );
        
        // n_ƏI_tɂȂĂȂ`FbN܂
        // FvxROI͋`f[^ŁAEE̍Wʒu(xs > xe, ys > ye)
        // tɂȂĂꍇłAւ̂܂܌ʂԂ܂̂ŁAӂĂ
        if ( m_ExeRegion->Getxe() < m_ExeRegion->Getxs() ) {
            dblTemp = m_ExeRegion->Getxs();
			m_ExeRegion->Putxs( m_ExeRegion->Getxe() );
            m_ExeRegion->Putxe( dblTemp );
		}
		if ( m_ExeRegion->Getye() < m_ExeRegion->Getys() ) {
            dblTemp = m_ExeRegion->Getys();
            m_ExeRegion->Putys( m_ExeRegion->Getye() );
            m_ExeRegion->Putye( dblTemp );
		}
	}

	// ͈͂̓Kp
    m_FvxDisplayEx->PutPenColor( 0xFF0000 );
    m_FvxDisplayEx->DrawData( 0, m_ExeRegion );

}

void CBlobDlg::OnChangeBinlevel() 
{
	// TODO: ꂪ RICHEDIT Rg[̏ꍇARg[́A lParam }XN
	// ł̘_a ENM_CHANGE tOt CRichEditCrtl().SetEventMask()
	// bZ[WRg[֑邽߂ CDialog::OnInitDialog() ֐I[o[
	// ChȂ肱̒ʒm𑗂܂B
	
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	UpdateData( TRUE );

	long BinLevel = 0;

	BinLevel = m_binlevel;
    
    if ( BinLevel < 0 ) BinLevel = 0 ;
    if ( BinLevel > 255 ) BinLevel = 255 ;
    
    m_FvxChangeImage->FixedLevel( m_FvxImageGray, m_FvxImageBin, BinLevel );
    m_FvxDisplayEx->DrawImage( m_FvxImageBin );
	
}

void CBlobDlg::OnClear() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	m_exetime = "";
	m_FvxDisplayEx->ClearOverlay( -1 );
	UpdateData( FALSE );
}

void CBlobDlg::OnLoadimage() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	UpdateData( TRUE );

	long BinLevel = 0;

	BinLevel = m_binlevel;
    
    if ( BinLevel < 0 ) BinLevel = 0 ;
    if ( BinLevel > 255 ) BinLevel = 255 ;
	
	// R_CAONX̐
	char szFilters[]="bitmap file(*.bmp)|*.bmp||";
	char szIniFilePath[_MAX_PATH];

	// spX擾
	::GetModuleFileName(GetModuleHandle(NULL), szIniFilePath, _MAX_PATH);

	CFileDialog cFileDlg (TRUE , "bmp", NULL , OFN_FILEMUSTEXIST| OFN_HIDEREADONLY, szFilters, this);
	cFileDlg.m_ofn.lpstrInitialDir = szIniFilePath ;

	if (cFileDlg.DoModal() == IDOK){
		m_FvxFileAccess->PutFilePath( _bstr_t( cFileDlg.GetPathName() ) );

		try {
		
			m_FvxFileAccess->LoadBitmap( m_FvxImageTemp );
		
		} catch(_com_error ) {

			long lngErr = 0;
			CString cStr;

			m_FvxFileAccess->GetErrReport( &lngErr );
			cStr.Format("Ǎ݂Ɏs܂Berr_no = %d", lngErr );
			MessageBox(cStr,"G[", MB_ICONWARNING | MB_OK);
			return;
		}

		// 摜^Cv`FbN
		if ( ( m_FvxImageTemp->GetImageType ()!=imageGray ) || 
			 ( m_FvxImageTemp->GetImageWidth()!=512 ) || ( m_FvxImageTemp->GetImageHeight()!=480 ) ){

			MessageBox("512*480 1/8bitO[摜ł͂܂","G[", MB_ICONWARNING | MB_OK);

            m_FvxImageTemp->PutBitPerPixel( 8 );
            m_FvxImageTemp->PutImageType( imageGray );
            m_FvxImageTemp->PutImageWidth( 512 );
            m_FvxImageTemp->PutImageHeight( 480 );

		}

		// QlZW
        if ( m_FvxImageTemp->GetBitPerPixel() == 1 ) {
            m_FvxImageGray->ClearImage();
            m_FvxImageTemp->CopyTo( m_FvxImageBin );
            m_FvxDisplayEx->DrawImage( m_FvxImageBin );
        } else if ( m_FvxImageTemp->GetBitPerPixel() == 8 ) {
            m_FvxImageTemp->CopyTo( m_FvxImageGray );
            m_FvxChangeImage->FixedLevel( m_FvxImageGray, m_FvxImageBin, BinLevel );
            m_FvxDisplayEx->DrawImage( m_FvxImageBin );
		} else {
			MessageBox("1bit/8bitȊObmpł","ǍG[", MB_ICONWARNING | MB_OK);
        }

	}
}

void CBlobDlg::OnSaveimage() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	char szFilters[]="bitmap file(*.bmp)|*.bmp||";
	char szIniFilePath[_MAX_PATH];

	// spX擾
	::GetModuleFileName(GetModuleHandle(NULL), szIniFilePath, _MAX_PATH);

	CFileDialog cFileDlg(FALSE , "bmp", NULL , OFN_FILEMUSTEXIST| OFN_HIDEREADONLY, szFilters, this);
	cFileDlg.m_ofn.lpstrInitialDir = szIniFilePath ;

	if (cFileDlg.DoModal() == IDOK){

		m_FvxFileAccess->PutFilePath ( _bstr_t( cFileDlg.GetPathName() ));

		try {
		
			m_FvxFileAccess->SaveBitmap( m_FvxImageBin );
		
		} catch(_com_error ) {

			long lngErr = 0;
			CString cStr;

			m_FvxFileAccess->GetErrReport( &lngErr );
			cStr.Format("ۑɎs܂Berr_no = %d", lngErr );
			MessageBox(cStr , "G[", MB_ICONWARNING | MB_OK);
			return;
		}
	}
}

// Qlvs
void CBlobDlg::OnExecute() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	long lngCount = 0;
	double dblTime = 0;

	if (!UpdateData( TRUE )) return;

	// ʏ
    m_FvxDisplayEx->ClearOverlay( -1 );

    if ( m_minsize < 1 ) {
		MessageBox("ŏʐϒl͂Pȏ̐lݒ肵Ă" , "p[^G[", MB_ICONWARNING | MB_OK);
		return ;
	}
    if ( m_minsize >= m_maxsize ) {
		MessageBox("ŏʐϒlőʐϒlƂȂ悤ݒ肵Ă" , "p[^G[", MB_ICONWARNING | MB_OK);
		return ;
	}

	// őEŏʐϐݒ
	m_FvxBlob->PutMinSize( m_minsize );
	m_FvxBlob->PutMaxSize( m_maxsize );
	
	// ]p
    if (( m_angle < -180 ) || ( m_angle > 180 )) {
		MessageBox("]p -180.0`180.0 ͈̔͂œ͂Ă" , "p[^G[", MB_ICONWARNING | MB_OK);
		return ;
	}
	m_FvxBlob->Putangle( m_angle );

	// ΏېFݒ
	m_FvxBlob->PutColor(( enum COLOR_TYPE ) m_color ); 

    // xOiojݒ
	m_FvxBlob->PutArrange(( enum ARRANGE_TYPE ) m_arrange );

	// ͈͐ڐG
	if ( m_wndtouch == TRUE ) m_FvxBlob->PutWindowTouch( ON );
	else m_FvxBlob->PutWindowTouch( OFF );

	// ͈͐ݒ
    m_FvxBlob->SetInspectArea( m_ExeRegion );

	long lngErr = 0;
	CString cStr;
	try {
		m_FvxPerformanceCounter->StartCount();
		// Qlvs
		m_FvxBlob->Execute( m_FvxImageBin , &lngCount );
		m_FvxPerformanceCounter->StopCount( &dblTime ); // ԑI
		m_FvxBlob->GetErrReport( &lngErr );
	} catch(_com_error ) {
		// G[oĂ邩mF	
		// KGetErrReport\bhgăG[ԍ擾Ă
		m_FvxBlob->GetErrReport( &lngErr );
		cStr.Format("QlvɎs܂Berr_no = %d", lngErr );
		MessageBox(cStr, "G[" , MB_ICONWARNING | MB_OK );
		return ;
	}

    if( lngErr == 0 ) {
		m_exetime.Format("%fms", dblTime );
		UpdateData( FALSE );

		// ʉʕ\
		CBlobResultDlg rdlg;
		rdlg.m_lngMaxBlobNo = lngCount - 1;
		rdlg.m_parent = this;
		rdlg.DoModal();
	}else{
		cStr.Format("err_no = %d", lngErr );
		MessageBox(cStr, "G[" , MB_ICONWARNING | MB_OK );
	}

}

void CBlobDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ
    // rfIfoCXI[vĂꍇ̓N[Y܂
	if ( m_blnVideoOpened == true ) {
		m_FvxVideo->CloseDevice();	
	}
}
